import { NgtCommonLight, provideCommonLightRef, coerceNumberProperty, startWithUndefined } from '@angular-three/core';
import * as i0 from '@angular/core';
import { Component, ChangeDetectionStrategy, Input, NgModule, Directive, Self, Optional } from '@angular/core';
import * as THREE from 'three';
import { merge, takeUntil } from 'rxjs';

// GENERATED
class NgtLightProbe extends NgtCommonLight {
    set sh(sh) {
        this.set({ sh });
    }
    get lightType() {
        return THREE.LightProbe;
    }
    get optionFields() {
        return Object.assign(Object.assign({}, super.optionFields), { sh: true });
    }
}
NgtLightProbe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtLightProbe, deps: null, target: i0.ɵɵFactoryTarget.Component });
NgtLightProbe.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.5", type: NgtLightProbe, selector: "ngt-light-probe", inputs: { sh: "sh" }, providers: [provideCommonLightRef(NgtLightProbe)], usesInheritance: true, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtLightProbe, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngt-light-probe',
                    template: '<ng-content></ng-content>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [provideCommonLightRef(NgtLightProbe)],
                }]
        }], propDecorators: { sh: [{
                type: Input
            }] } });
class NgtLightProbeModule {
}
NgtLightProbeModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtLightProbeModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgtLightProbeModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtLightProbeModule, declarations: [NgtLightProbe], exports: [NgtLightProbe] });
NgtLightProbeModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtLightProbeModule });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtLightProbeModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NgtLightProbe],
                    exports: [NgtLightProbe],
                }]
        }] });

// GENERATED
class NgtAmbientLight extends NgtCommonLight {
    get lightType() {
        return THREE.AmbientLight;
    }
}
NgtAmbientLight.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtAmbientLight, deps: null, target: i0.ɵɵFactoryTarget.Component });
NgtAmbientLight.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.5", type: NgtAmbientLight, selector: "ngt-ambient-light", providers: [provideCommonLightRef(NgtAmbientLight)], usesInheritance: true, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtAmbientLight, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngt-ambient-light',
                    template: '<ng-content></ng-content>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [provideCommonLightRef(NgtAmbientLight)],
                }]
        }] });
class NgtAmbientLightModule {
}
NgtAmbientLightModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtAmbientLightModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgtAmbientLightModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtAmbientLightModule, declarations: [NgtAmbientLight], exports: [NgtAmbientLight] });
NgtAmbientLightModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtAmbientLightModule });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtAmbientLightModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NgtAmbientLight],
                    exports: [NgtAmbientLight],
                }]
        }] });

// GENERATED
class NgtAmbientLightProbe extends NgtCommonLight {
    get lightType() {
        return THREE.AmbientLightProbe;
    }
}
NgtAmbientLightProbe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtAmbientLightProbe, deps: null, target: i0.ɵɵFactoryTarget.Component });
NgtAmbientLightProbe.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.5", type: NgtAmbientLightProbe, selector: "ngt-ambient-light-probe", providers: [provideCommonLightRef(NgtAmbientLightProbe)], usesInheritance: true, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtAmbientLightProbe, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngt-ambient-light-probe',
                    template: '<ng-content></ng-content>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [provideCommonLightRef(NgtAmbientLightProbe)],
                }]
        }] });
class NgtAmbientLightProbeModule {
}
NgtAmbientLightProbeModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtAmbientLightProbeModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgtAmbientLightProbeModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtAmbientLightProbeModule, declarations: [NgtAmbientLightProbe], exports: [NgtAmbientLightProbe] });
NgtAmbientLightProbeModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtAmbientLightProbeModule });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtAmbientLightProbeModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NgtAmbientLightProbe],
                    exports: [NgtAmbientLightProbe],
                }]
        }] });

// GENERATED
class NgtHemisphereLight extends NgtCommonLight {
    set skyColor(skyColor) {
        this.set({ skyColor });
    }
    set groundColor(groundColor) {
        this.set({ groundColor });
    }
    get lightType() {
        return THREE.HemisphereLight;
    }
    get optionFields() {
        return Object.assign(Object.assign({}, super.optionFields), { skyColor: true, groundColor: true });
    }
}
NgtHemisphereLight.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtHemisphereLight, deps: null, target: i0.ɵɵFactoryTarget.Component });
NgtHemisphereLight.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.5", type: NgtHemisphereLight, selector: "ngt-hemisphere-light", inputs: { skyColor: "skyColor", groundColor: "groundColor" }, providers: [provideCommonLightRef(NgtHemisphereLight)], usesInheritance: true, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtHemisphereLight, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngt-hemisphere-light',
                    template: '<ng-content></ng-content>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [provideCommonLightRef(NgtHemisphereLight)],
                }]
        }], propDecorators: { skyColor: [{
                type: Input
            }], groundColor: [{
                type: Input
            }] } });
class NgtHemisphereLightModule {
}
NgtHemisphereLightModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtHemisphereLightModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgtHemisphereLightModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtHemisphereLightModule, declarations: [NgtHemisphereLight], exports: [NgtHemisphereLight] });
NgtHemisphereLightModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtHemisphereLightModule });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtHemisphereLightModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NgtHemisphereLight],
                    exports: [NgtHemisphereLight],
                }]
        }] });

// GENERATED
class NgtHemisphereLightProbe extends NgtCommonLight {
    set skyColor(skyColor) {
        this.set({ skyColor });
    }
    set groundColor(groundColor) {
        this.set({ groundColor });
    }
    get lightType() {
        return THREE.HemisphereLightProbe;
    }
    get optionFields() {
        return Object.assign(Object.assign({}, super.optionFields), { skyColor: true, groundColor: true });
    }
}
NgtHemisphereLightProbe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtHemisphereLightProbe, deps: null, target: i0.ɵɵFactoryTarget.Component });
NgtHemisphereLightProbe.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.5", type: NgtHemisphereLightProbe, selector: "ngt-hemisphere-light-probe", inputs: { skyColor: "skyColor", groundColor: "groundColor" }, providers: [provideCommonLightRef(NgtHemisphereLightProbe)], usesInheritance: true, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtHemisphereLightProbe, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngt-hemisphere-light-probe',
                    template: '<ng-content></ng-content>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [provideCommonLightRef(NgtHemisphereLightProbe)],
                }]
        }], propDecorators: { skyColor: [{
                type: Input
            }], groundColor: [{
                type: Input
            }] } });
class NgtHemisphereLightProbeModule {
}
NgtHemisphereLightProbeModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtHemisphereLightProbeModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgtHemisphereLightProbeModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtHemisphereLightProbeModule, declarations: [NgtHemisphereLightProbe], exports: [NgtHemisphereLightProbe] });
NgtHemisphereLightProbeModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtHemisphereLightProbeModule });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtHemisphereLightProbeModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NgtHemisphereLightProbe],
                    exports: [NgtHemisphereLightProbe],
                }]
        }] });

// GENERATED
class NgtDirectionalLight extends NgtCommonLight {
    set target(target) {
        this.set({ target });
    }
    get lightType() {
        return THREE.DirectionalLight;
    }
    get optionFields() {
        return Object.assign(Object.assign({}, super.optionFields), { target: true });
    }
}
NgtDirectionalLight.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtDirectionalLight, deps: null, target: i0.ɵɵFactoryTarget.Component });
NgtDirectionalLight.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.5", type: NgtDirectionalLight, selector: "ngt-directional-light", inputs: { target: "target" }, providers: [provideCommonLightRef(NgtDirectionalLight)], usesInheritance: true, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtDirectionalLight, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngt-directional-light',
                    template: '<ng-content></ng-content>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [provideCommonLightRef(NgtDirectionalLight)],
                }]
        }], propDecorators: { target: [{
                type: Input
            }] } });
class NgtDirectionalLightModule {
}
NgtDirectionalLightModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtDirectionalLightModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgtDirectionalLightModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtDirectionalLightModule, declarations: [NgtDirectionalLight], exports: [NgtDirectionalLight] });
NgtDirectionalLightModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtDirectionalLightModule });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtDirectionalLightModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NgtDirectionalLight],
                    exports: [NgtDirectionalLight],
                }]
        }] });

// GENERATED
class NgtPointLight extends NgtCommonLight {
    set distance(distance) {
        this.set({ distance: coerceNumberProperty(distance) });
    }
    set decay(decay) {
        this.set({ decay: coerceNumberProperty(decay) });
    }
    set power(power) {
        this.set({ power: coerceNumberProperty(power) });
    }
    get lightType() {
        return THREE.PointLight;
    }
    get optionFields() {
        return Object.assign(Object.assign({}, super.optionFields), { distance: true, decay: true, power: true });
    }
}
NgtPointLight.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtPointLight, deps: null, target: i0.ɵɵFactoryTarget.Component });
NgtPointLight.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.5", type: NgtPointLight, selector: "ngt-point-light", inputs: { distance: "distance", decay: "decay", power: "power" }, providers: [provideCommonLightRef(NgtPointLight)], usesInheritance: true, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtPointLight, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngt-point-light',
                    template: '<ng-content></ng-content>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [provideCommonLightRef(NgtPointLight)],
                }]
        }], propDecorators: { distance: [{
                type: Input
            }], decay: [{
                type: Input
            }], power: [{
                type: Input
            }] } });
class NgtPointLightModule {
}
NgtPointLightModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtPointLightModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgtPointLightModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtPointLightModule, declarations: [NgtPointLight], exports: [NgtPointLight] });
NgtPointLightModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtPointLightModule });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtPointLightModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NgtPointLight],
                    exports: [NgtPointLight],
                }]
        }] });

// GENERATED
class NgtSpotLight extends NgtCommonLight {
    set distance(distance) {
        this.set({ distance: coerceNumberProperty(distance) });
    }
    set angle(angle) {
        this.set({ angle: coerceNumberProperty(angle) });
    }
    set penumbra(penumbra) {
        this.set({ penumbra: coerceNumberProperty(penumbra) });
    }
    set decay(decay) {
        this.set({ decay: coerceNumberProperty(decay) });
    }
    set target(target) {
        this.set({ target });
    }
    set power(power) {
        this.set({ power: coerceNumberProperty(power) });
    }
    get lightType() {
        return THREE.SpotLight;
    }
    get optionFields() {
        return Object.assign(Object.assign({}, super.optionFields), { distance: true, angle: true, penumbra: true, decay: true, target: true, power: true });
    }
}
NgtSpotLight.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtSpotLight, deps: null, target: i0.ɵɵFactoryTarget.Component });
NgtSpotLight.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.5", type: NgtSpotLight, selector: "ngt-spot-light", inputs: { distance: "distance", angle: "angle", penumbra: "penumbra", decay: "decay", target: "target", power: "power" }, providers: [provideCommonLightRef(NgtSpotLight)], usesInheritance: true, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtSpotLight, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngt-spot-light',
                    template: '<ng-content></ng-content>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [provideCommonLightRef(NgtSpotLight)],
                }]
        }], propDecorators: { distance: [{
                type: Input
            }], angle: [{
                type: Input
            }], penumbra: [{
                type: Input
            }], decay: [{
                type: Input
            }], target: [{
                type: Input
            }], power: [{
                type: Input
            }] } });
class NgtSpotLightModule {
}
NgtSpotLightModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtSpotLightModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgtSpotLightModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtSpotLightModule, declarations: [NgtSpotLight], exports: [NgtSpotLight] });
NgtSpotLightModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtSpotLightModule });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtSpotLightModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NgtSpotLight],
                    exports: [NgtSpotLight],
                }]
        }] });

// GENERATED
class NgtRectAreaLight extends NgtCommonLight {
    set width(width) {
        this.set({ width: coerceNumberProperty(width) });
    }
    set height(height) {
        this.set({ height: coerceNumberProperty(height) });
    }
    set power(power) {
        this.set({ power: coerceNumberProperty(power) });
    }
    get lightType() {
        return THREE.RectAreaLight;
    }
    get optionFields() {
        return Object.assign(Object.assign({}, super.optionFields), { width: true, height: true, power: true });
    }
}
NgtRectAreaLight.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtRectAreaLight, deps: null, target: i0.ɵɵFactoryTarget.Component });
NgtRectAreaLight.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.5", type: NgtRectAreaLight, selector: "ngt-rect-area-light", inputs: { width: "width", height: "height", power: "power" }, providers: [provideCommonLightRef(NgtRectAreaLight)], usesInheritance: true, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtRectAreaLight, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngt-rect-area-light',
                    template: '<ng-content></ng-content>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [provideCommonLightRef(NgtRectAreaLight)],
                }]
        }], propDecorators: { width: [{
                type: Input
            }], height: [{
                type: Input
            }], power: [{
                type: Input
            }] } });
class NgtRectAreaLightModule {
}
NgtRectAreaLightModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtRectAreaLightModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgtRectAreaLightModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtRectAreaLightModule, declarations: [NgtRectAreaLight], exports: [NgtRectAreaLight] });
NgtRectAreaLightModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtRectAreaLightModule });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtRectAreaLightModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NgtRectAreaLight],
                    exports: [NgtRectAreaLight],
                }]
        }] });

class NgtSpotLightPassThrough {
    constructor(host) {
        this.host = host;
        if (!host)
            return;
    }
    set ngtSpotLightPassThrough(wrapper) {
        this.assertWrapper(wrapper);
        merge(this.host.select((s) => s['distance']).pipe(startWithUndefined()), wrapper.select((s) => s['distance']).pipe(startWithUndefined()))
            .pipe(takeUntil(wrapper.destroy$))
            .subscribe((distance) => {
            this.host.distance = distance;
        });
        merge(this.host.select((s) => s['angle']).pipe(startWithUndefined()), wrapper.select((s) => s['angle']).pipe(startWithUndefined()))
            .pipe(takeUntil(wrapper.destroy$))
            .subscribe((angle) => {
            this.host.angle = angle;
        });
        merge(this.host.select((s) => s['penumbra']).pipe(startWithUndefined()), wrapper.select((s) => s['penumbra']).pipe(startWithUndefined()))
            .pipe(takeUntil(wrapper.destroy$))
            .subscribe((penumbra) => {
            this.host.penumbra = penumbra;
        });
        merge(this.host.select((s) => s['decay']).pipe(startWithUndefined()), wrapper.select((s) => s['decay']).pipe(startWithUndefined()))
            .pipe(takeUntil(wrapper.destroy$))
            .subscribe((decay) => {
            this.host.decay = decay;
        });
        merge(this.host.select((s) => s['target']).pipe(startWithUndefined()), wrapper.select((s) => s['target']).pipe(startWithUndefined()))
            .pipe(takeUntil(wrapper.destroy$))
            .subscribe((target) => {
            this.host.target = target;
        });
        merge(this.host.select((s) => s['power']).pipe(startWithUndefined()), wrapper.select((s) => s['power']).pipe(startWithUndefined()))
            .pipe(takeUntil(wrapper.destroy$))
            .subscribe((power) => {
            this.host.power = power;
        });
    }
    assertWrapper(wrapper) {
        if (!wrapper || !(wrapper instanceof NgtSpotLight)) {
            throw new Error('ngtSpotLightPassThrough wrapper is not a NgtSpotLight');
        }
    }
}
NgtSpotLightPassThrough.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtSpotLightPassThrough, deps: [{ token: NgtSpotLight, optional: true, self: true }], target: i0.ɵɵFactoryTarget.Directive });
NgtSpotLightPassThrough.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.3.5", type: NgtSpotLightPassThrough, selector: "[ngtSpotLightPassThrough]", inputs: { ngtSpotLightPassThrough: "ngtSpotLightPassThrough" }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtSpotLightPassThrough, decorators: [{
            type: Directive,
            args: [{
                    selector: '[ngtSpotLightPassThrough]',
                }]
        }], ctorParameters: function () {
        return [{ type: NgtSpotLight, decorators: [{
                        type: Self
                    }, {
                        type: Optional
                    }] }];
    }, propDecorators: { ngtSpotLightPassThrough: [{
                type: Input
            }] } });
class NgtSpotLightPassThroughModule {
}
NgtSpotLightPassThroughModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtSpotLightPassThroughModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgtSpotLightPassThroughModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtSpotLightPassThroughModule, declarations: [NgtSpotLightPassThrough], exports: [NgtSpotLightPassThrough] });
NgtSpotLightPassThroughModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtSpotLightPassThroughModule });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtSpotLightPassThroughModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NgtSpotLightPassThrough],
                    exports: [NgtSpotLightPassThrough],
                }]
        }] });

//GENERATED

/**
 * Generated bundle index. Do not edit.
 */

export { NgtAmbientLight, NgtAmbientLightModule, NgtAmbientLightProbe, NgtAmbientLightProbeModule, NgtDirectionalLight, NgtDirectionalLightModule, NgtHemisphereLight, NgtHemisphereLightModule, NgtHemisphereLightProbe, NgtHemisphereLightProbeModule, NgtLightProbe, NgtLightProbeModule, NgtPointLight, NgtPointLightModule, NgtRectAreaLight, NgtRectAreaLightModule, NgtSpotLight, NgtSpotLightModule, NgtSpotLightPassThrough, NgtSpotLightPassThroughModule };
//# sourceMappingURL=angular-three-core-lights.mjs.map
