import { NgtCommonMaterial, coerceBooleanProperty, provideCommonMaterialRef, coerceNumberProperty } from '@angular-three/core';
import * as i0 from '@angular/core';
import { Component, ChangeDetectionStrategy, Input, NgModule } from '@angular/core';
import * as THREE from 'three';

// GENERATED
class NgtShadowMaterial extends NgtCommonMaterial {
    set color(color) {
        this.set({ color });
    }
    set fog(fog) {
        this.set({ fog: coerceBooleanProperty(fog) });
    }
    get materialType() {
        return THREE.ShadowMaterial;
    }
    get optionFields() {
        return Object.assign(Object.assign({}, super.optionFields), { color: true, fog: true });
    }
}
NgtShadowMaterial.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtShadowMaterial, deps: null, target: i0.ɵɵFactoryTarget.Component });
NgtShadowMaterial.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.5", type: NgtShadowMaterial, selector: "ngt-shadow-material", inputs: { color: "color", fog: "fog" }, providers: [provideCommonMaterialRef(NgtShadowMaterial)], usesInheritance: true, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtShadowMaterial, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngt-shadow-material',
                    template: '<ng-content></ng-content>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [provideCommonMaterialRef(NgtShadowMaterial)],
                }]
        }], propDecorators: { color: [{
                type: Input
            }], fog: [{
                type: Input
            }] } });
class NgtShadowMaterialModule {
}
NgtShadowMaterialModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtShadowMaterialModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgtShadowMaterialModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtShadowMaterialModule, declarations: [NgtShadowMaterial], exports: [NgtShadowMaterial] });
NgtShadowMaterialModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtShadowMaterialModule });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtShadowMaterialModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NgtShadowMaterial],
                    exports: [NgtShadowMaterial],
                }]
        }] });

// GENERATED
class NgtSpriteMaterial extends NgtCommonMaterial {
    set color(color) {
        this.set({ color });
    }
    set map(map) {
        this.set({ map });
    }
    set alphaMap(alphaMap) {
        this.set({ alphaMap });
    }
    set rotation(rotation) {
        this.set({ rotation: coerceNumberProperty(rotation) });
    }
    set sizeAttenuation(sizeAttenuation) {
        this.set({ sizeAttenuation: coerceBooleanProperty(sizeAttenuation) });
    }
    set fog(fog) {
        this.set({ fog: coerceBooleanProperty(fog) });
    }
    get materialType() {
        return THREE.SpriteMaterial;
    }
    get optionFields() {
        return Object.assign(Object.assign({}, super.optionFields), { color: true, map: true, alphaMap: true, rotation: true, sizeAttenuation: true, fog: true });
    }
}
NgtSpriteMaterial.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtSpriteMaterial, deps: null, target: i0.ɵɵFactoryTarget.Component });
NgtSpriteMaterial.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.5", type: NgtSpriteMaterial, selector: "ngt-sprite-material", inputs: { color: "color", map: "map", alphaMap: "alphaMap", rotation: "rotation", sizeAttenuation: "sizeAttenuation", fog: "fog" }, providers: [provideCommonMaterialRef(NgtSpriteMaterial)], usesInheritance: true, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtSpriteMaterial, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngt-sprite-material',
                    template: '<ng-content></ng-content>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [provideCommonMaterialRef(NgtSpriteMaterial)],
                }]
        }], propDecorators: { color: [{
                type: Input
            }], map: [{
                type: Input
            }], alphaMap: [{
                type: Input
            }], rotation: [{
                type: Input
            }], sizeAttenuation: [{
                type: Input
            }], fog: [{
                type: Input
            }] } });
class NgtSpriteMaterialModule {
}
NgtSpriteMaterialModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtSpriteMaterialModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgtSpriteMaterialModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtSpriteMaterialModule, declarations: [NgtSpriteMaterial], exports: [NgtSpriteMaterial] });
NgtSpriteMaterialModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtSpriteMaterialModule });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtSpriteMaterialModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NgtSpriteMaterial],
                    exports: [NgtSpriteMaterial],
                }]
        }] });

// GENERATED
class NgtRawShaderMaterial extends NgtCommonMaterial {
    get materialType() {
        return THREE.RawShaderMaterial;
    }
}
NgtRawShaderMaterial.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtRawShaderMaterial, deps: null, target: i0.ɵɵFactoryTarget.Component });
NgtRawShaderMaterial.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.5", type: NgtRawShaderMaterial, selector: "ngt-raw-shader-material", providers: [provideCommonMaterialRef(NgtRawShaderMaterial)], usesInheritance: true, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtRawShaderMaterial, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngt-raw-shader-material',
                    template: '<ng-content></ng-content>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [provideCommonMaterialRef(NgtRawShaderMaterial)],
                }]
        }] });
class NgtRawShaderMaterialModule {
}
NgtRawShaderMaterialModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtRawShaderMaterialModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgtRawShaderMaterialModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtRawShaderMaterialModule, declarations: [NgtRawShaderMaterial], exports: [NgtRawShaderMaterial] });
NgtRawShaderMaterialModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtRawShaderMaterialModule });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtRawShaderMaterialModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NgtRawShaderMaterial],
                    exports: [NgtRawShaderMaterial],
                }]
        }] });

// GENERATED
class NgtShaderMaterial extends NgtCommonMaterial {
    set uniforms(uniforms) {
        this.set({ uniforms });
    }
    set vertexShader(vertexShader) {
        this.set({ vertexShader });
    }
    set fragmentShader(fragmentShader) {
        this.set({ fragmentShader });
    }
    set linewidth(linewidth) {
        this.set({ linewidth: coerceNumberProperty(linewidth) });
    }
    set wireframe(wireframe) {
        this.set({ wireframe: coerceBooleanProperty(wireframe) });
    }
    set wireframeLinewidth(wireframeLinewidth) {
        this.set({ wireframeLinewidth: coerceNumberProperty(wireframeLinewidth) });
    }
    set lights(lights) {
        this.set({ lights: coerceBooleanProperty(lights) });
    }
    set clipping(clipping) {
        this.set({ clipping: coerceBooleanProperty(clipping) });
    }
    set extensions(extensions) {
        this.set({ extensions: coerceBooleanProperty(extensions) });
    }
    set glslVersion(glslVersion) {
        this.set({ glslVersion });
    }
    get materialType() {
        return THREE.ShaderMaterial;
    }
    get optionFields() {
        return Object.assign(Object.assign({}, super.optionFields), { uniforms: true, vertexShader: true, fragmentShader: true, linewidth: true, wireframe: true, wireframeLinewidth: true, lights: true, clipping: true, extensions: true, glslVersion: true });
    }
}
NgtShaderMaterial.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtShaderMaterial, deps: null, target: i0.ɵɵFactoryTarget.Component });
NgtShaderMaterial.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.5", type: NgtShaderMaterial, selector: "ngt-shader-material", inputs: { uniforms: "uniforms", vertexShader: "vertexShader", fragmentShader: "fragmentShader", linewidth: "linewidth", wireframe: "wireframe", wireframeLinewidth: "wireframeLinewidth", lights: "lights", clipping: "clipping", extensions: "extensions", glslVersion: "glslVersion" }, providers: [provideCommonMaterialRef(NgtShaderMaterial)], usesInheritance: true, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtShaderMaterial, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngt-shader-material',
                    template: '<ng-content></ng-content>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [provideCommonMaterialRef(NgtShaderMaterial)],
                }]
        }], propDecorators: { uniforms: [{
                type: Input
            }], vertexShader: [{
                type: Input
            }], fragmentShader: [{
                type: Input
            }], linewidth: [{
                type: Input
            }], wireframe: [{
                type: Input
            }], wireframeLinewidth: [{
                type: Input
            }], lights: [{
                type: Input
            }], clipping: [{
                type: Input
            }], extensions: [{
                type: Input
            }], glslVersion: [{
                type: Input
            }] } });
class NgtShaderMaterialModule {
}
NgtShaderMaterialModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtShaderMaterialModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgtShaderMaterialModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtShaderMaterialModule, declarations: [NgtShaderMaterial], exports: [NgtShaderMaterial] });
NgtShaderMaterialModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtShaderMaterialModule });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtShaderMaterialModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NgtShaderMaterial],
                    exports: [NgtShaderMaterial],
                }]
        }] });

// GENERATED
class NgtPointsMaterial extends NgtCommonMaterial {
    set color(color) {
        this.set({ color });
    }
    set map(map) {
        this.set({ map });
    }
    set alphaMap(alphaMap) {
        this.set({ alphaMap });
    }
    set size(size) {
        this.set({ size: coerceNumberProperty(size) });
    }
    set sizeAttenuation(sizeAttenuation) {
        this.set({ sizeAttenuation: coerceBooleanProperty(sizeAttenuation) });
    }
    set fog(fog) {
        this.set({ fog: coerceBooleanProperty(fog) });
    }
    get materialType() {
        return THREE.PointsMaterial;
    }
    get optionFields() {
        return Object.assign(Object.assign({}, super.optionFields), { color: true, map: true, alphaMap: true, size: true, sizeAttenuation: true, fog: true });
    }
}
NgtPointsMaterial.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtPointsMaterial, deps: null, target: i0.ɵɵFactoryTarget.Component });
NgtPointsMaterial.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.5", type: NgtPointsMaterial, selector: "ngt-points-material", inputs: { color: "color", map: "map", alphaMap: "alphaMap", size: "size", sizeAttenuation: "sizeAttenuation", fog: "fog" }, providers: [provideCommonMaterialRef(NgtPointsMaterial)], usesInheritance: true, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtPointsMaterial, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngt-points-material',
                    template: '<ng-content></ng-content>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [provideCommonMaterialRef(NgtPointsMaterial)],
                }]
        }], propDecorators: { color: [{
                type: Input
            }], map: [{
                type: Input
            }], alphaMap: [{
                type: Input
            }], size: [{
                type: Input
            }], sizeAttenuation: [{
                type: Input
            }], fog: [{
                type: Input
            }] } });
class NgtPointsMaterialModule {
}
NgtPointsMaterialModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtPointsMaterialModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgtPointsMaterialModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtPointsMaterialModule, declarations: [NgtPointsMaterial], exports: [NgtPointsMaterial] });
NgtPointsMaterialModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtPointsMaterialModule });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtPointsMaterialModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NgtPointsMaterial],
                    exports: [NgtPointsMaterial],
                }]
        }] });

// GENERATED
class NgtMeshStandardMaterial extends NgtCommonMaterial {
    set color(color) {
        this.set({ color });
    }
    set roughness(roughness) {
        this.set({ roughness: coerceNumberProperty(roughness) });
    }
    set metalness(metalness) {
        this.set({ metalness: coerceNumberProperty(metalness) });
    }
    set map(map) {
        this.set({ map });
    }
    set lightMap(lightMap) {
        this.set({ lightMap });
    }
    set lightMapIntensity(lightMapIntensity) {
        this.set({ lightMapIntensity: coerceNumberProperty(lightMapIntensity) });
    }
    set aoMap(aoMap) {
        this.set({ aoMap });
    }
    set aoMapIntensity(aoMapIntensity) {
        this.set({ aoMapIntensity: coerceNumberProperty(aoMapIntensity) });
    }
    set emissive(emissive) {
        this.set({ emissive });
    }
    set emissiveIntensity(emissiveIntensity) {
        this.set({ emissiveIntensity: coerceNumberProperty(emissiveIntensity) });
    }
    set emissiveMap(emissiveMap) {
        this.set({ emissiveMap });
    }
    set bumpMap(bumpMap) {
        this.set({ bumpMap });
    }
    set bumpScale(bumpScale) {
        this.set({ bumpScale: coerceNumberProperty(bumpScale) });
    }
    set normalMap(normalMap) {
        this.set({ normalMap });
    }
    set normalMapType(normalMapType) {
        this.set({ normalMapType });
    }
    set normalScale(normalScale) {
        this.set({ normalScale });
    }
    set displacementMap(displacementMap) {
        this.set({ displacementMap });
    }
    set displacementScale(displacementScale) {
        this.set({ displacementScale: coerceNumberProperty(displacementScale) });
    }
    set displacementBias(displacementBias) {
        this.set({ displacementBias: coerceNumberProperty(displacementBias) });
    }
    set roughnessMap(roughnessMap) {
        this.set({ roughnessMap });
    }
    set metalnessMap(metalnessMap) {
        this.set({ metalnessMap });
    }
    set alphaMap(alphaMap) {
        this.set({ alphaMap });
    }
    set envMap(envMap) {
        this.set({ envMap });
    }
    set envMapIntensity(envMapIntensity) {
        this.set({ envMapIntensity: coerceNumberProperty(envMapIntensity) });
    }
    set wireframe(wireframe) {
        this.set({ wireframe: coerceBooleanProperty(wireframe) });
    }
    set wireframeLinewidth(wireframeLinewidth) {
        this.set({ wireframeLinewidth: coerceNumberProperty(wireframeLinewidth) });
    }
    set fog(fog) {
        this.set({ fog: coerceBooleanProperty(fog) });
    }
    set flatShading(flatShading) {
        this.set({ flatShading: coerceBooleanProperty(flatShading) });
    }
    get materialType() {
        return THREE.MeshStandardMaterial;
    }
    get optionFields() {
        return Object.assign(Object.assign({}, super.optionFields), { color: true, roughness: true, metalness: true, map: true, lightMap: true, lightMapIntensity: true, aoMap: true, aoMapIntensity: true, emissive: true, emissiveIntensity: true, emissiveMap: true, bumpMap: true, bumpScale: true, normalMap: true, normalMapType: true, normalScale: true, displacementMap: true, displacementScale: true, displacementBias: true, roughnessMap: true, metalnessMap: true, alphaMap: true, envMap: true, envMapIntensity: true, wireframe: true, wireframeLinewidth: true, fog: true, flatShading: true });
    }
}
NgtMeshStandardMaterial.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtMeshStandardMaterial, deps: null, target: i0.ɵɵFactoryTarget.Component });
NgtMeshStandardMaterial.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.5", type: NgtMeshStandardMaterial, selector: "ngt-mesh-standard-material", inputs: { color: "color", roughness: "roughness", metalness: "metalness", map: "map", lightMap: "lightMap", lightMapIntensity: "lightMapIntensity", aoMap: "aoMap", aoMapIntensity: "aoMapIntensity", emissive: "emissive", emissiveIntensity: "emissiveIntensity", emissiveMap: "emissiveMap", bumpMap: "bumpMap", bumpScale: "bumpScale", normalMap: "normalMap", normalMapType: "normalMapType", normalScale: "normalScale", displacementMap: "displacementMap", displacementScale: "displacementScale", displacementBias: "displacementBias", roughnessMap: "roughnessMap", metalnessMap: "metalnessMap", alphaMap: "alphaMap", envMap: "envMap", envMapIntensity: "envMapIntensity", wireframe: "wireframe", wireframeLinewidth: "wireframeLinewidth", fog: "fog", flatShading: "flatShading" }, providers: [provideCommonMaterialRef(NgtMeshStandardMaterial)], usesInheritance: true, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtMeshStandardMaterial, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngt-mesh-standard-material',
                    template: '<ng-content></ng-content>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [provideCommonMaterialRef(NgtMeshStandardMaterial)],
                }]
        }], propDecorators: { color: [{
                type: Input
            }], roughness: [{
                type: Input
            }], metalness: [{
                type: Input
            }], map: [{
                type: Input
            }], lightMap: [{
                type: Input
            }], lightMapIntensity: [{
                type: Input
            }], aoMap: [{
                type: Input
            }], aoMapIntensity: [{
                type: Input
            }], emissive: [{
                type: Input
            }], emissiveIntensity: [{
                type: Input
            }], emissiveMap: [{
                type: Input
            }], bumpMap: [{
                type: Input
            }], bumpScale: [{
                type: Input
            }], normalMap: [{
                type: Input
            }], normalMapType: [{
                type: Input
            }], normalScale: [{
                type: Input
            }], displacementMap: [{
                type: Input
            }], displacementScale: [{
                type: Input
            }], displacementBias: [{
                type: Input
            }], roughnessMap: [{
                type: Input
            }], metalnessMap: [{
                type: Input
            }], alphaMap: [{
                type: Input
            }], envMap: [{
                type: Input
            }], envMapIntensity: [{
                type: Input
            }], wireframe: [{
                type: Input
            }], wireframeLinewidth: [{
                type: Input
            }], fog: [{
                type: Input
            }], flatShading: [{
                type: Input
            }] } });
class NgtMeshStandardMaterialModule {
}
NgtMeshStandardMaterialModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtMeshStandardMaterialModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgtMeshStandardMaterialModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtMeshStandardMaterialModule, declarations: [NgtMeshStandardMaterial], exports: [NgtMeshStandardMaterial] });
NgtMeshStandardMaterialModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtMeshStandardMaterialModule });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtMeshStandardMaterialModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NgtMeshStandardMaterial],
                    exports: [NgtMeshStandardMaterial],
                }]
        }] });

// GENERATED
class NgtMeshPhysicalMaterial extends NgtMeshStandardMaterial {
    set clearcoat(clearcoat) {
        this.set({ clearcoat: coerceNumberProperty(clearcoat) });
    }
    set clearcoatMap(clearcoatMap) {
        this.set({ clearcoatMap });
    }
    set clearcoatRoughness(clearcoatRoughness) {
        this.set({ clearcoatRoughness: coerceNumberProperty(clearcoatRoughness) });
    }
    set clearcoatRoughnessMap(clearcoatRoughnessMap) {
        this.set({ clearcoatRoughnessMap });
    }
    set clearcoatNormalScale(clearcoatNormalScale) {
        this.set({ clearcoatNormalScale });
    }
    set clearcoatNormalMap(clearcoatNormalMap) {
        this.set({ clearcoatNormalMap });
    }
    set reflectivity(reflectivity) {
        this.set({ reflectivity: coerceNumberProperty(reflectivity) });
    }
    set ior(ior) {
        this.set({ ior: coerceNumberProperty(ior) });
    }
    set sheen(sheen) {
        this.set({ sheen: coerceNumberProperty(sheen) });
    }
    set sheenColor(sheenColor) {
        this.set({ sheenColor });
    }
    set sheenRoughness(sheenRoughness) {
        this.set({ sheenRoughness: coerceNumberProperty(sheenRoughness) });
    }
    set transmission(transmission) {
        this.set({ transmission: coerceNumberProperty(transmission) });
    }
    set transmissionMap(transmissionMap) {
        this.set({ transmissionMap });
    }
    set attenuationDistance(attenuationDistance) {
        this.set({ attenuationDistance: coerceNumberProperty(attenuationDistance) });
    }
    set attenuationColor(attenuationColor) {
        this.set({ attenuationColor });
    }
    set specularIntensity(specularIntensity) {
        this.set({ specularIntensity: coerceNumberProperty(specularIntensity) });
    }
    set specularColor(specularColor) {
        this.set({ specularColor });
    }
    set specularIntensityMap(specularIntensityMap) {
        this.set({ specularIntensityMap });
    }
    set specularColorMap(specularColorMap) {
        this.set({ specularColorMap });
    }
    get materialType() {
        return THREE.MeshPhysicalMaterial;
    }
    get optionFields() {
        return Object.assign(Object.assign({}, super.optionFields), { clearcoat: true, clearcoatMap: true, clearcoatRoughness: true, clearcoatRoughnessMap: true, clearcoatNormalScale: true, clearcoatNormalMap: true, reflectivity: true, ior: true, sheen: true, sheenColor: true, sheenRoughness: true, transmission: true, transmissionMap: true, attenuationDistance: true, attenuationColor: true, specularIntensity: true, specularColor: true, specularIntensityMap: true, specularColorMap: true });
    }
}
NgtMeshPhysicalMaterial.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtMeshPhysicalMaterial, deps: null, target: i0.ɵɵFactoryTarget.Component });
NgtMeshPhysicalMaterial.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.5", type: NgtMeshPhysicalMaterial, selector: "ngt-mesh-physical-material", inputs: { clearcoat: "clearcoat", clearcoatMap: "clearcoatMap", clearcoatRoughness: "clearcoatRoughness", clearcoatRoughnessMap: "clearcoatRoughnessMap", clearcoatNormalScale: "clearcoatNormalScale", clearcoatNormalMap: "clearcoatNormalMap", reflectivity: "reflectivity", ior: "ior", sheen: "sheen", sheenColor: "sheenColor", sheenRoughness: "sheenRoughness", transmission: "transmission", transmissionMap: "transmissionMap", attenuationDistance: "attenuationDistance", attenuationColor: "attenuationColor", specularIntensity: "specularIntensity", specularColor: "specularColor", specularIntensityMap: "specularIntensityMap", specularColorMap: "specularColorMap" }, providers: [provideCommonMaterialRef(NgtMeshPhysicalMaterial)], usesInheritance: true, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtMeshPhysicalMaterial, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngt-mesh-physical-material',
                    template: '<ng-content></ng-content>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [provideCommonMaterialRef(NgtMeshPhysicalMaterial)],
                }]
        }], propDecorators: { clearcoat: [{
                type: Input
            }], clearcoatMap: [{
                type: Input
            }], clearcoatRoughness: [{
                type: Input
            }], clearcoatRoughnessMap: [{
                type: Input
            }], clearcoatNormalScale: [{
                type: Input
            }], clearcoatNormalMap: [{
                type: Input
            }], reflectivity: [{
                type: Input
            }], ior: [{
                type: Input
            }], sheen: [{
                type: Input
            }], sheenColor: [{
                type: Input
            }], sheenRoughness: [{
                type: Input
            }], transmission: [{
                type: Input
            }], transmissionMap: [{
                type: Input
            }], attenuationDistance: [{
                type: Input
            }], attenuationColor: [{
                type: Input
            }], specularIntensity: [{
                type: Input
            }], specularColor: [{
                type: Input
            }], specularIntensityMap: [{
                type: Input
            }], specularColorMap: [{
                type: Input
            }] } });
class NgtMeshPhysicalMaterialModule {
}
NgtMeshPhysicalMaterialModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtMeshPhysicalMaterialModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgtMeshPhysicalMaterialModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtMeshPhysicalMaterialModule, declarations: [NgtMeshPhysicalMaterial], exports: [NgtMeshPhysicalMaterial] });
NgtMeshPhysicalMaterialModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtMeshPhysicalMaterialModule });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtMeshPhysicalMaterialModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NgtMeshPhysicalMaterial],
                    exports: [NgtMeshPhysicalMaterial],
                }]
        }] });

// GENERATED
class NgtMeshPhongMaterial extends NgtCommonMaterial {
    set color(color) {
        this.set({ color });
    }
    set specular(specular) {
        this.set({ specular });
    }
    set shininess(shininess) {
        this.set({ shininess: coerceNumberProperty(shininess) });
    }
    set opacity(opacity) {
        this.set({ opacity: coerceNumberProperty(opacity) });
    }
    set map(map) {
        this.set({ map });
    }
    set lightMap(lightMap) {
        this.set({ lightMap });
    }
    set lightMapIntensity(lightMapIntensity) {
        this.set({ lightMapIntensity: coerceNumberProperty(lightMapIntensity) });
    }
    set aoMap(aoMap) {
        this.set({ aoMap });
    }
    set aoMapIntensity(aoMapIntensity) {
        this.set({ aoMapIntensity: coerceNumberProperty(aoMapIntensity) });
    }
    set emissive(emissive) {
        this.set({ emissive });
    }
    set emissiveIntensity(emissiveIntensity) {
        this.set({ emissiveIntensity: coerceNumberProperty(emissiveIntensity) });
    }
    set emissiveMap(emissiveMap) {
        this.set({ emissiveMap });
    }
    set bumpMap(bumpMap) {
        this.set({ bumpMap });
    }
    set bumpScale(bumpScale) {
        this.set({ bumpScale: coerceNumberProperty(bumpScale) });
    }
    set normalMap(normalMap) {
        this.set({ normalMap });
    }
    set normalMapType(normalMapType) {
        this.set({ normalMapType });
    }
    set normalScale(normalScale) {
        this.set({ normalScale });
    }
    set displacementMap(displacementMap) {
        this.set({ displacementMap });
    }
    set displacementScale(displacementScale) {
        this.set({ displacementScale: coerceNumberProperty(displacementScale) });
    }
    set displacementBias(displacementBias) {
        this.set({ displacementBias: coerceNumberProperty(displacementBias) });
    }
    set specularMap(specularMap) {
        this.set({ specularMap });
    }
    set alphaMap(alphaMap) {
        this.set({ alphaMap });
    }
    set envMap(envMap) {
        this.set({ envMap });
    }
    set combine(combine) {
        this.set({ combine });
    }
    set reflectivity(reflectivity) {
        this.set({ reflectivity: coerceNumberProperty(reflectivity) });
    }
    set refractionRatio(refractionRatio) {
        this.set({ refractionRatio: coerceNumberProperty(refractionRatio) });
    }
    set wireframe(wireframe) {
        this.set({ wireframe: coerceBooleanProperty(wireframe) });
    }
    set wireframeLinewidth(wireframeLinewidth) {
        this.set({ wireframeLinewidth: coerceNumberProperty(wireframeLinewidth) });
    }
    set wireframeLinecap(wireframeLinecap) {
        this.set({ wireframeLinecap });
    }
    set wireframeLinejoin(wireframeLinejoin) {
        this.set({ wireframeLinejoin });
    }
    set fog(fog) {
        this.set({ fog: coerceBooleanProperty(fog) });
    }
    set flatShading(flatShading) {
        this.set({ flatShading: coerceBooleanProperty(flatShading) });
    }
    get materialType() {
        return THREE.MeshPhongMaterial;
    }
    get optionFields() {
        return Object.assign(Object.assign({}, super.optionFields), { color: true, specular: true, shininess: true, opacity: true, map: true, lightMap: true, lightMapIntensity: true, aoMap: true, aoMapIntensity: true, emissive: true, emissiveIntensity: true, emissiveMap: true, bumpMap: true, bumpScale: true, normalMap: true, normalMapType: true, normalScale: true, displacementMap: true, displacementScale: true, displacementBias: true, specularMap: true, alphaMap: true, envMap: true, combine: true, reflectivity: true, refractionRatio: true, wireframe: true, wireframeLinewidth: true, wireframeLinecap: true, wireframeLinejoin: true, fog: true, flatShading: true });
    }
}
NgtMeshPhongMaterial.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtMeshPhongMaterial, deps: null, target: i0.ɵɵFactoryTarget.Component });
NgtMeshPhongMaterial.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.5", type: NgtMeshPhongMaterial, selector: "ngt-mesh-phong-material", inputs: { color: "color", specular: "specular", shininess: "shininess", opacity: "opacity", map: "map", lightMap: "lightMap", lightMapIntensity: "lightMapIntensity", aoMap: "aoMap", aoMapIntensity: "aoMapIntensity", emissive: "emissive", emissiveIntensity: "emissiveIntensity", emissiveMap: "emissiveMap", bumpMap: "bumpMap", bumpScale: "bumpScale", normalMap: "normalMap", normalMapType: "normalMapType", normalScale: "normalScale", displacementMap: "displacementMap", displacementScale: "displacementScale", displacementBias: "displacementBias", specularMap: "specularMap", alphaMap: "alphaMap", envMap: "envMap", combine: "combine", reflectivity: "reflectivity", refractionRatio: "refractionRatio", wireframe: "wireframe", wireframeLinewidth: "wireframeLinewidth", wireframeLinecap: "wireframeLinecap", wireframeLinejoin: "wireframeLinejoin", fog: "fog", flatShading: "flatShading" }, providers: [provideCommonMaterialRef(NgtMeshPhongMaterial)], usesInheritance: true, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtMeshPhongMaterial, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngt-mesh-phong-material',
                    template: '<ng-content></ng-content>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [provideCommonMaterialRef(NgtMeshPhongMaterial)],
                }]
        }], propDecorators: { color: [{
                type: Input
            }], specular: [{
                type: Input
            }], shininess: [{
                type: Input
            }], opacity: [{
                type: Input
            }], map: [{
                type: Input
            }], lightMap: [{
                type: Input
            }], lightMapIntensity: [{
                type: Input
            }], aoMap: [{
                type: Input
            }], aoMapIntensity: [{
                type: Input
            }], emissive: [{
                type: Input
            }], emissiveIntensity: [{
                type: Input
            }], emissiveMap: [{
                type: Input
            }], bumpMap: [{
                type: Input
            }], bumpScale: [{
                type: Input
            }], normalMap: [{
                type: Input
            }], normalMapType: [{
                type: Input
            }], normalScale: [{
                type: Input
            }], displacementMap: [{
                type: Input
            }], displacementScale: [{
                type: Input
            }], displacementBias: [{
                type: Input
            }], specularMap: [{
                type: Input
            }], alphaMap: [{
                type: Input
            }], envMap: [{
                type: Input
            }], combine: [{
                type: Input
            }], reflectivity: [{
                type: Input
            }], refractionRatio: [{
                type: Input
            }], wireframe: [{
                type: Input
            }], wireframeLinewidth: [{
                type: Input
            }], wireframeLinecap: [{
                type: Input
            }], wireframeLinejoin: [{
                type: Input
            }], fog: [{
                type: Input
            }], flatShading: [{
                type: Input
            }] } });
class NgtMeshPhongMaterialModule {
}
NgtMeshPhongMaterialModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtMeshPhongMaterialModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgtMeshPhongMaterialModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtMeshPhongMaterialModule, declarations: [NgtMeshPhongMaterial], exports: [NgtMeshPhongMaterial] });
NgtMeshPhongMaterialModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtMeshPhongMaterialModule });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtMeshPhongMaterialModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NgtMeshPhongMaterial],
                    exports: [NgtMeshPhongMaterial],
                }]
        }] });

// GENERATED
class NgtMeshToonMaterial extends NgtCommonMaterial {
    set color(color) {
        this.set({ color });
    }
    set opacity(opacity) {
        this.set({ opacity: coerceNumberProperty(opacity) });
    }
    set gradientMap(gradientMap) {
        this.set({ gradientMap });
    }
    set map(map) {
        this.set({ map });
    }
    set lightMap(lightMap) {
        this.set({ lightMap });
    }
    set lightMapIntensity(lightMapIntensity) {
        this.set({ lightMapIntensity: coerceNumberProperty(lightMapIntensity) });
    }
    set aoMap(aoMap) {
        this.set({ aoMap });
    }
    set aoMapIntensity(aoMapIntensity) {
        this.set({ aoMapIntensity: coerceNumberProperty(aoMapIntensity) });
    }
    set emissive(emissive) {
        this.set({ emissive });
    }
    set emissiveIntensity(emissiveIntensity) {
        this.set({ emissiveIntensity: coerceNumberProperty(emissiveIntensity) });
    }
    set emissiveMap(emissiveMap) {
        this.set({ emissiveMap });
    }
    set bumpMap(bumpMap) {
        this.set({ bumpMap });
    }
    set bumpScale(bumpScale) {
        this.set({ bumpScale: coerceNumberProperty(bumpScale) });
    }
    set normalMap(normalMap) {
        this.set({ normalMap });
    }
    set normalMapType(normalMapType) {
        this.set({ normalMapType });
    }
    set normalScale(normalScale) {
        this.set({ normalScale });
    }
    set displacementMap(displacementMap) {
        this.set({ displacementMap });
    }
    set displacementScale(displacementScale) {
        this.set({ displacementScale: coerceNumberProperty(displacementScale) });
    }
    set displacementBias(displacementBias) {
        this.set({ displacementBias: coerceNumberProperty(displacementBias) });
    }
    set alphaMap(alphaMap) {
        this.set({ alphaMap });
    }
    set wireframe(wireframe) {
        this.set({ wireframe: coerceBooleanProperty(wireframe) });
    }
    set wireframeLinewidth(wireframeLinewidth) {
        this.set({ wireframeLinewidth: coerceNumberProperty(wireframeLinewidth) });
    }
    set wireframeLinecap(wireframeLinecap) {
        this.set({ wireframeLinecap });
    }
    set wireframeLinejoin(wireframeLinejoin) {
        this.set({ wireframeLinejoin });
    }
    set fog(fog) {
        this.set({ fog: coerceBooleanProperty(fog) });
    }
    get materialType() {
        return THREE.MeshToonMaterial;
    }
    get optionFields() {
        return Object.assign(Object.assign({}, super.optionFields), { color: true, opacity: true, gradientMap: true, map: true, lightMap: true, lightMapIntensity: true, aoMap: true, aoMapIntensity: true, emissive: true, emissiveIntensity: true, emissiveMap: true, bumpMap: true, bumpScale: true, normalMap: true, normalMapType: true, normalScale: true, displacementMap: true, displacementScale: true, displacementBias: true, alphaMap: true, wireframe: true, wireframeLinewidth: true, wireframeLinecap: true, wireframeLinejoin: true, fog: true });
    }
}
NgtMeshToonMaterial.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtMeshToonMaterial, deps: null, target: i0.ɵɵFactoryTarget.Component });
NgtMeshToonMaterial.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.5", type: NgtMeshToonMaterial, selector: "ngt-mesh-toon-material", inputs: { color: "color", opacity: "opacity", gradientMap: "gradientMap", map: "map", lightMap: "lightMap", lightMapIntensity: "lightMapIntensity", aoMap: "aoMap", aoMapIntensity: "aoMapIntensity", emissive: "emissive", emissiveIntensity: "emissiveIntensity", emissiveMap: "emissiveMap", bumpMap: "bumpMap", bumpScale: "bumpScale", normalMap: "normalMap", normalMapType: "normalMapType", normalScale: "normalScale", displacementMap: "displacementMap", displacementScale: "displacementScale", displacementBias: "displacementBias", alphaMap: "alphaMap", wireframe: "wireframe", wireframeLinewidth: "wireframeLinewidth", wireframeLinecap: "wireframeLinecap", wireframeLinejoin: "wireframeLinejoin", fog: "fog" }, providers: [provideCommonMaterialRef(NgtMeshToonMaterial)], usesInheritance: true, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtMeshToonMaterial, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngt-mesh-toon-material',
                    template: '<ng-content></ng-content>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [provideCommonMaterialRef(NgtMeshToonMaterial)],
                }]
        }], propDecorators: { color: [{
                type: Input
            }], opacity: [{
                type: Input
            }], gradientMap: [{
                type: Input
            }], map: [{
                type: Input
            }], lightMap: [{
                type: Input
            }], lightMapIntensity: [{
                type: Input
            }], aoMap: [{
                type: Input
            }], aoMapIntensity: [{
                type: Input
            }], emissive: [{
                type: Input
            }], emissiveIntensity: [{
                type: Input
            }], emissiveMap: [{
                type: Input
            }], bumpMap: [{
                type: Input
            }], bumpScale: [{
                type: Input
            }], normalMap: [{
                type: Input
            }], normalMapType: [{
                type: Input
            }], normalScale: [{
                type: Input
            }], displacementMap: [{
                type: Input
            }], displacementScale: [{
                type: Input
            }], displacementBias: [{
                type: Input
            }], alphaMap: [{
                type: Input
            }], wireframe: [{
                type: Input
            }], wireframeLinewidth: [{
                type: Input
            }], wireframeLinecap: [{
                type: Input
            }], wireframeLinejoin: [{
                type: Input
            }], fog: [{
                type: Input
            }] } });
class NgtMeshToonMaterialModule {
}
NgtMeshToonMaterialModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtMeshToonMaterialModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgtMeshToonMaterialModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtMeshToonMaterialModule, declarations: [NgtMeshToonMaterial], exports: [NgtMeshToonMaterial] });
NgtMeshToonMaterialModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtMeshToonMaterialModule });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtMeshToonMaterialModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NgtMeshToonMaterial],
                    exports: [NgtMeshToonMaterial],
                }]
        }] });

// GENERATED
class NgtMeshNormalMaterial extends NgtCommonMaterial {
    set bumpMap(bumpMap) {
        this.set({ bumpMap });
    }
    set bumpScale(bumpScale) {
        this.set({ bumpScale: coerceNumberProperty(bumpScale) });
    }
    set normalMap(normalMap) {
        this.set({ normalMap });
    }
    set normalMapType(normalMapType) {
        this.set({ normalMapType });
    }
    set normalScale(normalScale) {
        this.set({ normalScale });
    }
    set displacementMap(displacementMap) {
        this.set({ displacementMap });
    }
    set displacementScale(displacementScale) {
        this.set({ displacementScale: coerceNumberProperty(displacementScale) });
    }
    set displacementBias(displacementBias) {
        this.set({ displacementBias: coerceNumberProperty(displacementBias) });
    }
    set wireframe(wireframe) {
        this.set({ wireframe: coerceBooleanProperty(wireframe) });
    }
    set wireframeLinewidth(wireframeLinewidth) {
        this.set({ wireframeLinewidth: coerceNumberProperty(wireframeLinewidth) });
    }
    set flatShading(flatShading) {
        this.set({ flatShading: coerceBooleanProperty(flatShading) });
    }
    get materialType() {
        return THREE.MeshNormalMaterial;
    }
    get optionFields() {
        return Object.assign(Object.assign({}, super.optionFields), { bumpMap: true, bumpScale: true, normalMap: true, normalMapType: true, normalScale: true, displacementMap: true, displacementScale: true, displacementBias: true, wireframe: true, wireframeLinewidth: true, flatShading: true });
    }
}
NgtMeshNormalMaterial.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtMeshNormalMaterial, deps: null, target: i0.ɵɵFactoryTarget.Component });
NgtMeshNormalMaterial.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.5", type: NgtMeshNormalMaterial, selector: "ngt-mesh-normal-material", inputs: { bumpMap: "bumpMap", bumpScale: "bumpScale", normalMap: "normalMap", normalMapType: "normalMapType", normalScale: "normalScale", displacementMap: "displacementMap", displacementScale: "displacementScale", displacementBias: "displacementBias", wireframe: "wireframe", wireframeLinewidth: "wireframeLinewidth", flatShading: "flatShading" }, providers: [provideCommonMaterialRef(NgtMeshNormalMaterial)], usesInheritance: true, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtMeshNormalMaterial, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngt-mesh-normal-material',
                    template: '<ng-content></ng-content>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [provideCommonMaterialRef(NgtMeshNormalMaterial)],
                }]
        }], propDecorators: { bumpMap: [{
                type: Input
            }], bumpScale: [{
                type: Input
            }], normalMap: [{
                type: Input
            }], normalMapType: [{
                type: Input
            }], normalScale: [{
                type: Input
            }], displacementMap: [{
                type: Input
            }], displacementScale: [{
                type: Input
            }], displacementBias: [{
                type: Input
            }], wireframe: [{
                type: Input
            }], wireframeLinewidth: [{
                type: Input
            }], flatShading: [{
                type: Input
            }] } });
class NgtMeshNormalMaterialModule {
}
NgtMeshNormalMaterialModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtMeshNormalMaterialModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgtMeshNormalMaterialModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtMeshNormalMaterialModule, declarations: [NgtMeshNormalMaterial], exports: [NgtMeshNormalMaterial] });
NgtMeshNormalMaterialModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtMeshNormalMaterialModule });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtMeshNormalMaterialModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NgtMeshNormalMaterial],
                    exports: [NgtMeshNormalMaterial],
                }]
        }] });

// GENERATED
class NgtMeshLambertMaterial extends NgtCommonMaterial {
    set color(color) {
        this.set({ color });
    }
    set emissive(emissive) {
        this.set({ emissive });
    }
    set emissiveIntensity(emissiveIntensity) {
        this.set({ emissiveIntensity: coerceNumberProperty(emissiveIntensity) });
    }
    set emissiveMap(emissiveMap) {
        this.set({ emissiveMap });
    }
    set map(map) {
        this.set({ map });
    }
    set lightMap(lightMap) {
        this.set({ lightMap });
    }
    set lightMapIntensity(lightMapIntensity) {
        this.set({ lightMapIntensity: coerceNumberProperty(lightMapIntensity) });
    }
    set aoMap(aoMap) {
        this.set({ aoMap });
    }
    set aoMapIntensity(aoMapIntensity) {
        this.set({ aoMapIntensity: coerceNumberProperty(aoMapIntensity) });
    }
    set specularMap(specularMap) {
        this.set({ specularMap });
    }
    set alphaMap(alphaMap) {
        this.set({ alphaMap });
    }
    set envMap(envMap) {
        this.set({ envMap });
    }
    set combine(combine) {
        this.set({ combine });
    }
    set reflectivity(reflectivity) {
        this.set({ reflectivity: coerceNumberProperty(reflectivity) });
    }
    set refractionRatio(refractionRatio) {
        this.set({ refractionRatio: coerceNumberProperty(refractionRatio) });
    }
    set wireframe(wireframe) {
        this.set({ wireframe: coerceBooleanProperty(wireframe) });
    }
    set wireframeLinewidth(wireframeLinewidth) {
        this.set({ wireframeLinewidth: coerceNumberProperty(wireframeLinewidth) });
    }
    set wireframeLinecap(wireframeLinecap) {
        this.set({ wireframeLinecap });
    }
    set wireframeLinejoin(wireframeLinejoin) {
        this.set({ wireframeLinejoin });
    }
    set fog(fog) {
        this.set({ fog: coerceBooleanProperty(fog) });
    }
    get materialType() {
        return THREE.MeshLambertMaterial;
    }
    get optionFields() {
        return Object.assign(Object.assign({}, super.optionFields), { color: true, emissive: true, emissiveIntensity: true, emissiveMap: true, map: true, lightMap: true, lightMapIntensity: true, aoMap: true, aoMapIntensity: true, specularMap: true, alphaMap: true, envMap: true, combine: true, reflectivity: true, refractionRatio: true, wireframe: true, wireframeLinewidth: true, wireframeLinecap: true, wireframeLinejoin: true, fog: true });
    }
}
NgtMeshLambertMaterial.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtMeshLambertMaterial, deps: null, target: i0.ɵɵFactoryTarget.Component });
NgtMeshLambertMaterial.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.5", type: NgtMeshLambertMaterial, selector: "ngt-mesh-lambert-material", inputs: { color: "color", emissive: "emissive", emissiveIntensity: "emissiveIntensity", emissiveMap: "emissiveMap", map: "map", lightMap: "lightMap", lightMapIntensity: "lightMapIntensity", aoMap: "aoMap", aoMapIntensity: "aoMapIntensity", specularMap: "specularMap", alphaMap: "alphaMap", envMap: "envMap", combine: "combine", reflectivity: "reflectivity", refractionRatio: "refractionRatio", wireframe: "wireframe", wireframeLinewidth: "wireframeLinewidth", wireframeLinecap: "wireframeLinecap", wireframeLinejoin: "wireframeLinejoin", fog: "fog" }, providers: [provideCommonMaterialRef(NgtMeshLambertMaterial)], usesInheritance: true, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtMeshLambertMaterial, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngt-mesh-lambert-material',
                    template: '<ng-content></ng-content>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [provideCommonMaterialRef(NgtMeshLambertMaterial)],
                }]
        }], propDecorators: { color: [{
                type: Input
            }], emissive: [{
                type: Input
            }], emissiveIntensity: [{
                type: Input
            }], emissiveMap: [{
                type: Input
            }], map: [{
                type: Input
            }], lightMap: [{
                type: Input
            }], lightMapIntensity: [{
                type: Input
            }], aoMap: [{
                type: Input
            }], aoMapIntensity: [{
                type: Input
            }], specularMap: [{
                type: Input
            }], alphaMap: [{
                type: Input
            }], envMap: [{
                type: Input
            }], combine: [{
                type: Input
            }], reflectivity: [{
                type: Input
            }], refractionRatio: [{
                type: Input
            }], wireframe: [{
                type: Input
            }], wireframeLinewidth: [{
                type: Input
            }], wireframeLinecap: [{
                type: Input
            }], wireframeLinejoin: [{
                type: Input
            }], fog: [{
                type: Input
            }] } });
class NgtMeshLambertMaterialModule {
}
NgtMeshLambertMaterialModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtMeshLambertMaterialModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgtMeshLambertMaterialModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtMeshLambertMaterialModule, declarations: [NgtMeshLambertMaterial], exports: [NgtMeshLambertMaterial] });
NgtMeshLambertMaterialModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtMeshLambertMaterialModule });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtMeshLambertMaterialModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NgtMeshLambertMaterial],
                    exports: [NgtMeshLambertMaterial],
                }]
        }] });

// GENERATED
class NgtMeshDepthMaterial extends NgtCommonMaterial {
    set map(map) {
        this.set({ map });
    }
    set alphaMap(alphaMap) {
        this.set({ alphaMap });
    }
    set depthPacking(depthPacking) {
        this.set({ depthPacking });
    }
    set displacementMap(displacementMap) {
        this.set({ displacementMap });
    }
    set displacementScale(displacementScale) {
        this.set({ displacementScale: coerceNumberProperty(displacementScale) });
    }
    set displacementBias(displacementBias) {
        this.set({ displacementBias: coerceNumberProperty(displacementBias) });
    }
    set wireframe(wireframe) {
        this.set({ wireframe: coerceBooleanProperty(wireframe) });
    }
    set wireframeLinewidth(wireframeLinewidth) {
        this.set({ wireframeLinewidth: coerceNumberProperty(wireframeLinewidth) });
    }
    get materialType() {
        return THREE.MeshDepthMaterial;
    }
    get optionFields() {
        return Object.assign(Object.assign({}, super.optionFields), { map: true, alphaMap: true, depthPacking: true, displacementMap: true, displacementScale: true, displacementBias: true, wireframe: true, wireframeLinewidth: true });
    }
}
NgtMeshDepthMaterial.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtMeshDepthMaterial, deps: null, target: i0.ɵɵFactoryTarget.Component });
NgtMeshDepthMaterial.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.5", type: NgtMeshDepthMaterial, selector: "ngt-mesh-depth-material", inputs: { map: "map", alphaMap: "alphaMap", depthPacking: "depthPacking", displacementMap: "displacementMap", displacementScale: "displacementScale", displacementBias: "displacementBias", wireframe: "wireframe", wireframeLinewidth: "wireframeLinewidth" }, providers: [provideCommonMaterialRef(NgtMeshDepthMaterial)], usesInheritance: true, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtMeshDepthMaterial, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngt-mesh-depth-material',
                    template: '<ng-content></ng-content>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [provideCommonMaterialRef(NgtMeshDepthMaterial)],
                }]
        }], propDecorators: { map: [{
                type: Input
            }], alphaMap: [{
                type: Input
            }], depthPacking: [{
                type: Input
            }], displacementMap: [{
                type: Input
            }], displacementScale: [{
                type: Input
            }], displacementBias: [{
                type: Input
            }], wireframe: [{
                type: Input
            }], wireframeLinewidth: [{
                type: Input
            }] } });
class NgtMeshDepthMaterialModule {
}
NgtMeshDepthMaterialModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtMeshDepthMaterialModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgtMeshDepthMaterialModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtMeshDepthMaterialModule, declarations: [NgtMeshDepthMaterial], exports: [NgtMeshDepthMaterial] });
NgtMeshDepthMaterialModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtMeshDepthMaterialModule });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtMeshDepthMaterialModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NgtMeshDepthMaterial],
                    exports: [NgtMeshDepthMaterial],
                }]
        }] });

// GENERATED
class NgtMeshDistanceMaterial extends NgtCommonMaterial {
    set map(map) {
        this.set({ map });
    }
    set alphaMap(alphaMap) {
        this.set({ alphaMap });
    }
    set displacementMap(displacementMap) {
        this.set({ displacementMap });
    }
    set displacementScale(displacementScale) {
        this.set({ displacementScale: coerceNumberProperty(displacementScale) });
    }
    set displacementBias(displacementBias) {
        this.set({ displacementBias: coerceNumberProperty(displacementBias) });
    }
    set farDistance(farDistance) {
        this.set({ farDistance: coerceNumberProperty(farDistance) });
    }
    set nearDistance(nearDistance) {
        this.set({ nearDistance: coerceNumberProperty(nearDistance) });
    }
    set referencePosition(referencePosition) {
        this.set({ referencePosition });
    }
    get materialType() {
        return THREE.MeshDistanceMaterial;
    }
    get optionFields() {
        return Object.assign(Object.assign({}, super.optionFields), { map: true, alphaMap: true, displacementMap: true, displacementScale: true, displacementBias: true, farDistance: true, nearDistance: true, referencePosition: true });
    }
}
NgtMeshDistanceMaterial.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtMeshDistanceMaterial, deps: null, target: i0.ɵɵFactoryTarget.Component });
NgtMeshDistanceMaterial.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.5", type: NgtMeshDistanceMaterial, selector: "ngt-mesh-distance-material", inputs: { map: "map", alphaMap: "alphaMap", displacementMap: "displacementMap", displacementScale: "displacementScale", displacementBias: "displacementBias", farDistance: "farDistance", nearDistance: "nearDistance", referencePosition: "referencePosition" }, providers: [provideCommonMaterialRef(NgtMeshDistanceMaterial)], usesInheritance: true, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtMeshDistanceMaterial, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngt-mesh-distance-material',
                    template: '<ng-content></ng-content>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [provideCommonMaterialRef(NgtMeshDistanceMaterial)],
                }]
        }], propDecorators: { map: [{
                type: Input
            }], alphaMap: [{
                type: Input
            }], displacementMap: [{
                type: Input
            }], displacementScale: [{
                type: Input
            }], displacementBias: [{
                type: Input
            }], farDistance: [{
                type: Input
            }], nearDistance: [{
                type: Input
            }], referencePosition: [{
                type: Input
            }] } });
class NgtMeshDistanceMaterialModule {
}
NgtMeshDistanceMaterialModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtMeshDistanceMaterialModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgtMeshDistanceMaterialModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtMeshDistanceMaterialModule, declarations: [NgtMeshDistanceMaterial], exports: [NgtMeshDistanceMaterial] });
NgtMeshDistanceMaterialModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtMeshDistanceMaterialModule });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtMeshDistanceMaterialModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NgtMeshDistanceMaterial],
                    exports: [NgtMeshDistanceMaterial],
                }]
        }] });

// GENERATED
class NgtMeshBasicMaterial extends NgtCommonMaterial {
    set color(color) {
        this.set({ color });
    }
    set opacity(opacity) {
        this.set({ opacity: coerceNumberProperty(opacity) });
    }
    set map(map) {
        this.set({ map });
    }
    set lightMap(lightMap) {
        this.set({ lightMap });
    }
    set lightMapIntensity(lightMapIntensity) {
        this.set({ lightMapIntensity: coerceNumberProperty(lightMapIntensity) });
    }
    set aoMap(aoMap) {
        this.set({ aoMap });
    }
    set aoMapIntensity(aoMapIntensity) {
        this.set({ aoMapIntensity: coerceNumberProperty(aoMapIntensity) });
    }
    set specularMap(specularMap) {
        this.set({ specularMap });
    }
    set alphaMap(alphaMap) {
        this.set({ alphaMap });
    }
    set fog(fog) {
        this.set({ fog: coerceBooleanProperty(fog) });
    }
    set envMap(envMap) {
        this.set({ envMap });
    }
    set combine(combine) {
        this.set({ combine });
    }
    set reflectivity(reflectivity) {
        this.set({ reflectivity: coerceNumberProperty(reflectivity) });
    }
    set refractionRatio(refractionRatio) {
        this.set({ refractionRatio: coerceNumberProperty(refractionRatio) });
    }
    set wireframe(wireframe) {
        this.set({ wireframe: coerceBooleanProperty(wireframe) });
    }
    set wireframeLinewidth(wireframeLinewidth) {
        this.set({ wireframeLinewidth: coerceNumberProperty(wireframeLinewidth) });
    }
    set wireframeLinecap(wireframeLinecap) {
        this.set({ wireframeLinecap });
    }
    set wireframeLinejoin(wireframeLinejoin) {
        this.set({ wireframeLinejoin });
    }
    get materialType() {
        return THREE.MeshBasicMaterial;
    }
    get optionFields() {
        return Object.assign(Object.assign({}, super.optionFields), { color: true, opacity: true, map: true, lightMap: true, lightMapIntensity: true, aoMap: true, aoMapIntensity: true, specularMap: true, alphaMap: true, fog: true, envMap: true, combine: true, reflectivity: true, refractionRatio: true, wireframe: true, wireframeLinewidth: true, wireframeLinecap: true, wireframeLinejoin: true });
    }
}
NgtMeshBasicMaterial.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtMeshBasicMaterial, deps: null, target: i0.ɵɵFactoryTarget.Component });
NgtMeshBasicMaterial.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.5", type: NgtMeshBasicMaterial, selector: "ngt-mesh-basic-material", inputs: { color: "color", opacity: "opacity", map: "map", lightMap: "lightMap", lightMapIntensity: "lightMapIntensity", aoMap: "aoMap", aoMapIntensity: "aoMapIntensity", specularMap: "specularMap", alphaMap: "alphaMap", fog: "fog", envMap: "envMap", combine: "combine", reflectivity: "reflectivity", refractionRatio: "refractionRatio", wireframe: "wireframe", wireframeLinewidth: "wireframeLinewidth", wireframeLinecap: "wireframeLinecap", wireframeLinejoin: "wireframeLinejoin" }, providers: [provideCommonMaterialRef(NgtMeshBasicMaterial)], usesInheritance: true, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtMeshBasicMaterial, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngt-mesh-basic-material',
                    template: '<ng-content></ng-content>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [provideCommonMaterialRef(NgtMeshBasicMaterial)],
                }]
        }], propDecorators: { color: [{
                type: Input
            }], opacity: [{
                type: Input
            }], map: [{
                type: Input
            }], lightMap: [{
                type: Input
            }], lightMapIntensity: [{
                type: Input
            }], aoMap: [{
                type: Input
            }], aoMapIntensity: [{
                type: Input
            }], specularMap: [{
                type: Input
            }], alphaMap: [{
                type: Input
            }], fog: [{
                type: Input
            }], envMap: [{
                type: Input
            }], combine: [{
                type: Input
            }], reflectivity: [{
                type: Input
            }], refractionRatio: [{
                type: Input
            }], wireframe: [{
                type: Input
            }], wireframeLinewidth: [{
                type: Input
            }], wireframeLinecap: [{
                type: Input
            }], wireframeLinejoin: [{
                type: Input
            }] } });
class NgtMeshBasicMaterialModule {
}
NgtMeshBasicMaterialModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtMeshBasicMaterialModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgtMeshBasicMaterialModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtMeshBasicMaterialModule, declarations: [NgtMeshBasicMaterial], exports: [NgtMeshBasicMaterial] });
NgtMeshBasicMaterialModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtMeshBasicMaterialModule });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtMeshBasicMaterialModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NgtMeshBasicMaterial],
                    exports: [NgtMeshBasicMaterial],
                }]
        }] });

// GENERATED
class NgtMeshMatcapMaterial extends NgtCommonMaterial {
    set color(color) {
        this.set({ color });
    }
    set matcap(matcap) {
        this.set({ matcap });
    }
    set map(map) {
        this.set({ map });
    }
    set bumpMap(bumpMap) {
        this.set({ bumpMap });
    }
    set bumpScale(bumpScale) {
        this.set({ bumpScale: coerceNumberProperty(bumpScale) });
    }
    set normalMap(normalMap) {
        this.set({ normalMap });
    }
    set normalMapType(normalMapType) {
        this.set({ normalMapType });
    }
    set normalScale(normalScale) {
        this.set({ normalScale });
    }
    set displacementMap(displacementMap) {
        this.set({ displacementMap });
    }
    set displacementScale(displacementScale) {
        this.set({ displacementScale: coerceNumberProperty(displacementScale) });
    }
    set displacementBias(displacementBias) {
        this.set({ displacementBias: coerceNumberProperty(displacementBias) });
    }
    set alphaMap(alphaMap) {
        this.set({ alphaMap });
    }
    set fog(fog) {
        this.set({ fog: coerceBooleanProperty(fog) });
    }
    set flatShading(flatShading) {
        this.set({ flatShading: coerceBooleanProperty(flatShading) });
    }
    get materialType() {
        return THREE.MeshMatcapMaterial;
    }
    get optionFields() {
        return Object.assign(Object.assign({}, super.optionFields), { color: true, matcap: true, map: true, bumpMap: true, bumpScale: true, normalMap: true, normalMapType: true, normalScale: true, displacementMap: true, displacementScale: true, displacementBias: true, alphaMap: true, fog: true, flatShading: true });
    }
}
NgtMeshMatcapMaterial.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtMeshMatcapMaterial, deps: null, target: i0.ɵɵFactoryTarget.Component });
NgtMeshMatcapMaterial.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.5", type: NgtMeshMatcapMaterial, selector: "ngt-mesh-matcap-material", inputs: { color: "color", matcap: "matcap", map: "map", bumpMap: "bumpMap", bumpScale: "bumpScale", normalMap: "normalMap", normalMapType: "normalMapType", normalScale: "normalScale", displacementMap: "displacementMap", displacementScale: "displacementScale", displacementBias: "displacementBias", alphaMap: "alphaMap", fog: "fog", flatShading: "flatShading" }, providers: [provideCommonMaterialRef(NgtMeshMatcapMaterial)], usesInheritance: true, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtMeshMatcapMaterial, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngt-mesh-matcap-material',
                    template: '<ng-content></ng-content>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [provideCommonMaterialRef(NgtMeshMatcapMaterial)],
                }]
        }], propDecorators: { color: [{
                type: Input
            }], matcap: [{
                type: Input
            }], map: [{
                type: Input
            }], bumpMap: [{
                type: Input
            }], bumpScale: [{
                type: Input
            }], normalMap: [{
                type: Input
            }], normalMapType: [{
                type: Input
            }], normalScale: [{
                type: Input
            }], displacementMap: [{
                type: Input
            }], displacementScale: [{
                type: Input
            }], displacementBias: [{
                type: Input
            }], alphaMap: [{
                type: Input
            }], fog: [{
                type: Input
            }], flatShading: [{
                type: Input
            }] } });
class NgtMeshMatcapMaterialModule {
}
NgtMeshMatcapMaterialModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtMeshMatcapMaterialModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgtMeshMatcapMaterialModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtMeshMatcapMaterialModule, declarations: [NgtMeshMatcapMaterial], exports: [NgtMeshMatcapMaterial] });
NgtMeshMatcapMaterialModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtMeshMatcapMaterialModule });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtMeshMatcapMaterialModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NgtMeshMatcapMaterial],
                    exports: [NgtMeshMatcapMaterial],
                }]
        }] });

// GENERATED
class NgtLineBasicMaterial extends NgtCommonMaterial {
    set color(color) {
        this.set({ color });
    }
    set linewidth(linewidth) {
        this.set({ linewidth: coerceNumberProperty(linewidth) });
    }
    set linecap(linecap) {
        this.set({ linecap });
    }
    set linejoin(linejoin) {
        this.set({ linejoin });
    }
    get materialType() {
        return THREE.LineBasicMaterial;
    }
    get optionFields() {
        return Object.assign(Object.assign({}, super.optionFields), { color: true, linewidth: true, linecap: true, linejoin: true });
    }
}
NgtLineBasicMaterial.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtLineBasicMaterial, deps: null, target: i0.ɵɵFactoryTarget.Component });
NgtLineBasicMaterial.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.5", type: NgtLineBasicMaterial, selector: "ngt-line-basic-material", inputs: { color: "color", linewidth: "linewidth", linecap: "linecap", linejoin: "linejoin" }, providers: [provideCommonMaterialRef(NgtLineBasicMaterial)], usesInheritance: true, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtLineBasicMaterial, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngt-line-basic-material',
                    template: '<ng-content></ng-content>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [provideCommonMaterialRef(NgtLineBasicMaterial)],
                }]
        }], propDecorators: { color: [{
                type: Input
            }], linewidth: [{
                type: Input
            }], linecap: [{
                type: Input
            }], linejoin: [{
                type: Input
            }] } });
class NgtLineBasicMaterialModule {
}
NgtLineBasicMaterialModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtLineBasicMaterialModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgtLineBasicMaterialModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtLineBasicMaterialModule, declarations: [NgtLineBasicMaterial], exports: [NgtLineBasicMaterial] });
NgtLineBasicMaterialModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtLineBasicMaterialModule });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtLineBasicMaterialModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NgtLineBasicMaterial],
                    exports: [NgtLineBasicMaterial],
                }]
        }] });

// GENERATED
class NgtLineDashedMaterial extends NgtLineBasicMaterial {
    set scale(scale) {
        this.set({ scale: coerceNumberProperty(scale) });
    }
    set dashSize(dashSize) {
        this.set({ dashSize: coerceNumberProperty(dashSize) });
    }
    set gapSize(gapSize) {
        this.set({ gapSize: coerceNumberProperty(gapSize) });
    }
    get materialType() {
        return THREE.LineDashedMaterial;
    }
    get optionFields() {
        return Object.assign(Object.assign({}, super.optionFields), { scale: true, dashSize: true, gapSize: true });
    }
}
NgtLineDashedMaterial.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtLineDashedMaterial, deps: null, target: i0.ɵɵFactoryTarget.Component });
NgtLineDashedMaterial.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.5", type: NgtLineDashedMaterial, selector: "ngt-line-dashed-material", inputs: { scale: "scale", dashSize: "dashSize", gapSize: "gapSize" }, providers: [provideCommonMaterialRef(NgtLineDashedMaterial)], usesInheritance: true, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtLineDashedMaterial, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngt-line-dashed-material',
                    template: '<ng-content></ng-content>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [provideCommonMaterialRef(NgtLineDashedMaterial)],
                }]
        }], propDecorators: { scale: [{
                type: Input
            }], dashSize: [{
                type: Input
            }], gapSize: [{
                type: Input
            }] } });
class NgtLineDashedMaterialModule {
}
NgtLineDashedMaterialModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtLineDashedMaterialModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgtLineDashedMaterialModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtLineDashedMaterialModule, declarations: [NgtLineDashedMaterial], exports: [NgtLineDashedMaterial] });
NgtLineDashedMaterialModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtLineDashedMaterialModule });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtLineDashedMaterialModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NgtLineDashedMaterial],
                    exports: [NgtLineDashedMaterial],
                }]
        }] });

// GENERATED

/**
 * Generated bundle index. Do not edit.
 */

export { NgtLineBasicMaterial, NgtLineBasicMaterialModule, NgtLineDashedMaterial, NgtLineDashedMaterialModule, NgtMeshBasicMaterial, NgtMeshBasicMaterialModule, NgtMeshDepthMaterial, NgtMeshDepthMaterialModule, NgtMeshDistanceMaterial, NgtMeshDistanceMaterialModule, NgtMeshLambertMaterial, NgtMeshLambertMaterialModule, NgtMeshMatcapMaterial, NgtMeshMatcapMaterialModule, NgtMeshNormalMaterial, NgtMeshNormalMaterialModule, NgtMeshPhongMaterial, NgtMeshPhongMaterialModule, NgtMeshPhysicalMaterial, NgtMeshPhysicalMaterialModule, NgtMeshStandardMaterial, NgtMeshStandardMaterialModule, NgtMeshToonMaterial, NgtMeshToonMaterialModule, NgtPointsMaterial, NgtPointsMaterialModule, NgtRawShaderMaterial, NgtRawShaderMaterialModule, NgtShaderMaterial, NgtShaderMaterialModule, NgtShadowMaterial, NgtShadowMaterialModule, NgtSpriteMaterial, NgtSpriteMaterialModule };
//# sourceMappingURL=angular-three-core-materials.mjs.map
