import { NgtComponentStore, coerceNumberProperty, tapEffect, addCallback, addAfterCallback } from '@angular-three/core';
import { DOCUMENT } from '@angular/common';
import * as i0 from '@angular/core';
import { Component, ChangeDetectionStrategy, Inject, Input, NgModule } from '@angular/core';
import Stats from 'three/examples/jsm/libs/stats.module';

class NgtStats extends NgtComponentStore {
    constructor(zone, { body }) {
        super();
        this.zone = zone;
        this._showPanel = 0;
        this.node = body;
        this._stats = Stats();
    }
    set showPanel(showPanel) {
        this._showPanel = coerceNumberProperty(showPanel);
    }
    get stats() {
        return this._stats;
    }
    ngOnInit() {
        this.zone.runOutsideAngular(() => {
            this.effect(tapEffect(() => {
                if (this.parent) {
                    this.node = this.parent;
                }
                this._stats.showPanel(this._showPanel);
                this.node.appendChild(this._stats.dom);
                const beginCallbackCleanup = addCallback(() => this._stats.begin());
                const endCallbackCleanup = addAfterCallback(() => this._stats.end());
                return () => {
                    if (this._stats) {
                        this.node.removeChild(this._stats.dom);
                        beginCallbackCleanup();
                        endCallbackCleanup();
                    }
                };
            }))();
        });
    }
}
NgtStats.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtStats, deps: [{ token: i0.NgZone }, { token: DOCUMENT }], target: i0.ɵɵFactoryTarget.Component });
NgtStats.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.5", type: NgtStats, selector: "ngt-stats", inputs: { parent: "parent", showPanel: "showPanel" }, usesInheritance: true, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtStats, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngt-stats',
                    template: '<ng-content></ng-content>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                }]
        }], ctorParameters: function () { return [{ type: i0.NgZone }, { type: Document, decorators: [{
                    type: Inject,
                    args: [DOCUMENT]
                }] }]; }, propDecorators: { parent: [{
                type: Input
            }], showPanel: [{
                type: Input
            }] } });
class NgtStatsModule {
}
NgtStatsModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtStatsModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgtStatsModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtStatsModule, declarations: [NgtStats], exports: [NgtStats] });
NgtStatsModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtStatsModule });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.5", ngImport: i0, type: NgtStatsModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NgtStats],
                    exports: [NgtStats],
                }]
        }] });

/**
 * Generated bundle index. Do not edit.
 */

export { NgtStats, NgtStatsModule };
//# sourceMappingURL=angular-three-core-stats.mjs.map
