import { ElementRef, NgZone } from '@angular/core';
import { Observable } from 'rxjs';
import * as THREE from 'three';
import { NgtResizeResult } from '../services/resize';
import type { NgtBeforeRenderRecord, NgtCamera, NgtPerformanceOptions, NgtState } from '../types';
import { NgtComponentStore } from './component-store';
import * as i0 from "@angular/core";
export declare class NgtStore extends NgtComponentStore<NgtState> {
    private parentStore;
    private resizeResult$;
    private zone;
    private readonly pointer;
    private readonly position;
    private readonly defaultTarget;
    private readonly tempTarget;
    readonly ready$: Observable<boolean>;
    readonly camera$: Observable<NgtCamera & {
        manual?: boolean | undefined;
    }>;
    readonly scene$: Observable<THREE.Scene>;
    readonly gl$: Observable<THREE.WebGLRenderer>;
    readonly raycaster$: Observable<THREE.Raycaster>;
    readonly active$: Observable<boolean>;
    private allConstructed$;
    private performanceTimeoutId;
    private dimensions$;
    constructor({ nativeElement: { clientWidth, clientHeight } }: ElementRef<HTMLElement>, performanceOptions: NgtPerformanceOptions, { devicePixelRatio }: Window, parentStore: NgtStore, resizeResult$: Observable<NgtResizeResult>, zone: NgZone);
    init(canvasElement: HTMLCanvasElement, rootStateMap: Map<Element, () => NgtState>, invalidate: (state?: () => NgtState) => void, advance: (timestamp: number, runGlobalCallbacks?: boolean, state?: () => NgtState, frame?: THREE.XRFrame) => void): void;
    registerBeforeRender(record: NgtBeforeRenderRecord): () => void;
    unregisterBeforeRender(uuid: string): void;
    addInteraction(interaction: THREE.Object3D): void;
    removeInteraction(uuid: string): void;
    readonly startLoop: (observableOrValue: NgtState | Observable<NgtState>) => import("rxjs").Subscription;
    private readonly initRenderer;
    private readonly resize;
    private readonly updateDimensions;
    private readonly registerBeforeRenderEffect;
    private readonly updateSubscribers;
    private initEvents;
    private connectElement;
    private disconnectElement;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtStore, [null, null, null, { optional: true; skipSelf: true; }, null, null]>;
    static ɵprov: i0.ɵɵInjectableDeclaration<NgtStore>;
}
