import * as THREE from 'three';
import { NgtInstance, NgtInstanceState } from '../abstracts/instance';
import type { AnyConstructor, NumberInput } from '../types';
import * as i0 from "@angular/core";
export interface NgtCommonCurveState<TCurve extends THREE.Curve<THREE.Vector> = THREE.Curve<THREE.Vector>> extends NgtInstanceState<TCurve> {
    arcLengthDivisions?: number;
}
export declare abstract class NgtCommonCurve<TCurve extends THREE.Curve<THREE.Vector> = THREE.Curve<THREE.Vector>> extends NgtInstance<TCurve, NgtCommonCurveState<TCurve>> {
    abstract get curveType(): AnyConstructor<TCurve>;
    set args(v: ConstructorParameters<AnyConstructor<TCurve>>);
    set arcLengthDivisions(arcLengthDivisions: NumberInput);
    ngOnInit(): void;
    protected postPrepare(curve: TCurve): void;
    private readonly init;
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtCommonCurve<any>, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<NgtCommonCurve<any>, never, never, { "args": "args"; "arcLengthDivisions": "arcLengthDivisions"; }, {}, never>;
}
